// $Id: Actors.H 15422 2015-11-13 21:06:21Z igor $
// This is a GGS file, licensed under the GPL

/*
    (c) Igor Durdanovic, igord@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
//: Actors.H (bof) (c) Igor Durdanovic

#ifndef Actors_H
#define Actors_H

#include "CPP.H"
#include "String.H"
#include <memory>

class Signal;
class Stat;
class IO;
class IO_Server;
class IO_FILE;
class TIME_Server;
class MSG_english;
class IO_TCP_Mux;

struct GAS
{
  GAS();
  ~GAS();
  void init();
  
  sint4  time_log;
  sint4  time_stat;
  ccptrc file_log;

  const String empty;
  
  const uint4 file_max_buf_len;
  const uint4 user_max_buf_len;
  const uint4 serv_max_buf_len;

  IO_FILE*     vc_con;
  Signal*      vc_sig;
  TIME_Server* vc_time;
  IO_Server*   vc_ios;
  IO_FILE*     vc_log;
  Stat*        vc_stat;
  IO_TCP_Mux*  vc_mux; // set internally
};

extern std::unique_ptr<GAS> gas;

#endif

//: Actors.H (eof) (c) Igor
